﻿Imports System.Globalization

''' <summary>
''' Checks if TransactionTemplates are available and also if there are any.
''' </summary>
Public Class Multi_transtemp_visibility
    Implements IMultiValueConverter

    Public Function Convert(values() As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IMultiValueConverter.Convert

        If (ComponentModel.DesignerProperties.GetIsInDesignMode(Application.Current.MainWindow)) Then
            Return Visibility.Collapsed
        End If
        If values(0) Is Nothing Then Return Visibility.Collapsed
        If values(1) Is Nothing Then Return Visibility.Collapsed

        'values(0) indicates if active in settings:
        If DirectCast(values(0), Nullable(Of Boolean)) = True Then
            'Is enabled
            If DirectCast(values(1), ListCollectionView).Count > 0 Then
                Return Visibility.Visible
            Else
                Return Visibility.Collapsed
            End If
        Else
            Return Visibility.Collapsed
        End If

        Return Visibility.Collapsed
    End Function

    Public Function ConvertBack(value As Object, targetTypes() As Type, parameter As Object, culture As CultureInfo) As Object() Implements IMultiValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class