﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

''' <summary>
''' Class for Storing the Widgets Definition of the Dashboard
''' </summary>
Public Class widgets_v01
    Inherits model_base

    'The definition must contain a sortorder and the widgettype stored as string value => typeof(object)
    'The parameters are optional and can be used to store preset values of a specific widet.

    Dim v_id As Integer
    Dim v_sortorder As Integer
    Dim v_widgettype_str As String
    Dim v_para_str1 As String
    Dim v_para_str2 As String
    Dim v_para_str3 As String
    Dim v_para_str4 As String
    Dim v_para_dec1 As Decimal = 1D
    Dim v_para_dec2 As Decimal = 0D
    Dim v_para_dec3 As Decimal = 0D
    Dim v_para_date1 As Date = Date.Now
    Dim v_para_date2 As Date = Date.Now
    Dim v_para_int1 As Integer = 1
    Dim v_para_int2 As Integer = 2
    Dim v_para_int3 As Integer = 3
    Dim v_para_int4 As Integer = 4
    Dim v_para_int5 As Integer = 5
    Dim v_para_bol1 As Boolean? = False


    <Key>
    Public Property Id As Integer
        Get
            Return v_id
        End Get
        Set(value As Integer)
            If v_id <> value Then
                v_id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property sortorder As Integer
        Get
            Return v_sortorder
        End Get
        Set(value As Integer)
            If v_sortorder <> value Then
                v_sortorder = value
                NotifyPropertyChanged("sortorder")
            End If
        End Set
    End Property

    Public Property widgettype_str As String
        Get
            Return v_widgettype_str
        End Get
        Set(value As String)
            If v_widgettype_str <> value Then
                v_widgettype_str = value
                NotifyPropertyChanged("widgettype_str")
            End If
        End Set
    End Property

    Public Property para_str1 As String
        Get
            Return v_para_str1
        End Get
        Set(value As String)
            If v_para_str1 <> value Then
                v_para_str1 = value
                NotifyPropertyChanged("para_str1")
            End If
        End Set
    End Property

    Public Property para_str2 As String
        Get
            Return v_para_str2
        End Get
        Set(value As String)
            If v_para_str2 <> value Then
                v_para_str2 = value
                NotifyPropertyChanged("para_str2")
            End If
        End Set
    End Property

    Public Property para_str3 As String
        Get
            Return v_para_str3
        End Get
        Set(value As String)
            If v_para_str3 <> value Then
                v_para_str3 = value
                NotifyPropertyChanged("para_str3")
            End If
        End Set
    End Property

    Public Property para_str4 As String
        Get
            Return v_para_str4
        End Get
        Set(value As String)
            If v_para_str4 <> value Then
                v_para_str4 = value
                NotifyPropertyChanged("para_str4")
            End If
        End Set
    End Property

    Public Property para_dec1 As Decimal
        Get
            Return v_para_dec1
        End Get
        Set(value As Decimal)
            If v_para_dec1 <> value Then
                v_para_dec1 = value
                NotifyPropertyChanged("para_dec1")
                NotifyPropertyChanged("ValLabelStep")
                NotifyPropertyChanged("ValTicksstep")
            End If
        End Set
    End Property

    Public Property para_dec2 As Decimal
        Get
            Return v_para_dec2
        End Get
        Set(value As Decimal)
            If v_para_dec2 <> value Then
                v_para_dec2 = value
                NotifyPropertyChanged("para_dec2")
            End If
        End Set
    End Property

    Public Property para_dec3 As Decimal
        Get
            Return v_para_dec3
        End Get
        Set(value As Decimal)
            If v_para_dec3 <> value Then
                v_para_dec3 = value
                NotifyPropertyChanged("para_dec3")
            End If
        End Set
    End Property

    Public Property para_date1 As Date
        Get
            Return v_para_date1
        End Get
        Set(value As Date)
            v_para_date1 = value
            NotifyPropertyChanged("para_date1")
        End Set
    End Property

    Public Property para_date2 As Date
        Get
            Return v_para_date2
        End Get
        Set(value As Date)
            v_para_date2 = value
            NotifyPropertyChanged("para_date2")
        End Set
    End Property


    Public Property para_int1 As Integer
        Get
            Return v_para_int1
        End Get
        Set(value As Integer)
            If v_para_int1 <> value Then
                v_para_int1 = value
                NotifyPropertyChanged("para_int1")
            End If
        End Set
    End Property

    Public Property para_int2 As Integer
        Get
            Return v_para_int2
        End Get
        Set(value As Integer)
            If v_para_int2 <> value Then
                v_para_int2 = value
                NotifyPropertyChanged("para_int2")
            End If
        End Set
    End Property

    Public Property para_int3 As Integer
        Get
            Return v_para_int3
        End Get
        Set(value As Integer)
            If v_para_int3 <> value Then
                v_para_int3 = value
                NotifyPropertyChanged("para_int3")
            End If
        End Set
    End Property

    Public Property para_int4 As Integer
        Get
            Return v_para_int4
        End Get
        Set(value As Integer)
            If v_para_int4 <> value Then
                v_para_int4 = value
                NotifyPropertyChanged("para_int4")
            End If
        End Set
    End Property

    Public Property para_int5 As Integer
        Get
            Return v_para_int5
        End Get
        Set(value As Integer)
            If v_para_int5 <> value Then
                v_para_int5 = value
                NotifyPropertyChanged("para_int5")
            End If
        End Set
    End Property

    Public Property para_bol1 As Boolean?
        Get
            Return v_para_bol1
        End Get
        Set(value As Boolean?)
            If v_para_bol1 <> value Then
                v_para_bol1 = value
                NotifyPropertyChanged("para_bol1")
            End If
        End Set
    End Property

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Dim result As String = String.Empty
            Select Case columnName
                Case "widgettype_str"
                    If String.IsNullOrEmpty(widgettype_str) Then result = "Widgettype darf nicht leer sein"
                Case "sortorder"
                    If sortorder = Nothing Then result = "Sortierung muss angegeben werden"
                Case Else
                    Return result
            End Select
            If String.IsNullOrEmpty(result) Then
                v_haserrors = False
            Else
                v_haserrors = True
            End If

            NotifyPropertyChanged("hasErrors")
            Return result
        End Get
    End Property
#End Region


#Region "Gauge Values"
    'Add some properties for the gauge:
    'definition:
    'LabelsStep="5000" TicksStep="500"
    'Labelsstep is para_dec1 / 3
    'Ticksstep = is para_dec1 / 30

    Public ReadOnly Property ValLabelStep As Double
        Get
            If para_dec1 = Nothing Then Return 1
            If para_dec1 = 1 Then Return 0.5
            Dim v_value As Double = para_dec1 / 3
            Debug.Print("ValLabelStep: " & v_value.ToString)
            Return v_value
        End Get
    End Property

    Public ReadOnly Property ValTicksstep As Double
        Get
            If para_dec1 = Nothing Then Return 0.5
            If para_dec1 = 1 Then Return 0.25
            Dim v_value As Double = para_dec1 / 6
            Debug.Print("ValTicksstep: " & v_value.ToString)
            Return v_value
        End Get
    End Property
#End Region

End Class
