﻿Public Class cls_RepPeriodsHeaderItem
    Inherits GalaSoft.MvvmLight.ObservableObject

    Dim v_bezeichnug As String
    Dim v_datespan As String
    Dim v_pos_value As Decimal = 0D
    Dim v_neg_value As Decimal = 0D

    Sub New()

    End Sub

    Sub New(v_bez As String, v_date As String, Optional v_pos As Decimal = 0D, Optional v_neg As Decimal = 0D)
        Bezeichnung = v_bez
        DateSpan = v_date
        PosValue = v_pos
        NegValue = v_neg
    End Sub

    Public Property Bezeichnung As String
        Get
            Return v_bezeichnug
        End Get
        Set(value As String)
            If v_bezeichnug <> value Then
                v_bezeichnug = value
                RaisePropertyChanged("Bezeichnung")
            End If
        End Set
    End Property

    Public Property DateSpan As String
        Get
            Return v_datespan
        End Get
        Set(value As String)
            If v_datespan <> value Then
                v_datespan = value
                RaisePropertyChanged("DateSpan")
            End If
        End Set
    End Property

    Public Property PosValue As Decimal
        Get
            Return v_pos_value
        End Get
        Set(value As Decimal)
            If v_pos_value <> value Then
                v_pos_value = value
                RaisePropertyChanged("PosValue")
            End If
        End Set
    End Property

    Public Property NegValue As Decimal
        Get
            Return v_neg_value
        End Get
        Set(value As Decimal)
            If v_neg_value <> value Then
                v_neg_value = value
                RaisePropertyChanged("NegValue")
            End If
        End Set
    End Property

    Public ReadOnly Property PeriodValue As Decimal
        Get
            If PosValue = Nothing OrElse NegValue = Nothing Then Return 0
            Return PosValue + NegValue
        End Get
    End Property

End Class
