﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Status:

        Private WithEvents __status As New ObservableCollection(Of trans_status_v01)
        ''' <summary>
        ''' Alle Transaktionstypen
        ''' </summary>
        ''' <returns></returns>
        Public Property TransStatus As ListCollectionView
        Public Property TransStatus_Aktiv As ListCollectionView

        Private Sub StatusLoad()
            __status.Clear()
            dbo.m_trans_status_v01.Load
            __status = dbo.m_trans_status_v01.Local
            TransStatus = New ListCollectionView(__status)
            TransStatus_Aktiv = New ListCollectionView(__status)
            TransStatus_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.ObjAktiv)
        End Sub

        Private Sub __status_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __status.CollectionChanged
            'If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not TransStatus Is Nothing Then
                If Not TransStatus.MoveCurrentToNext Then TransStatus.MoveCurrentToPrevious()
            End If
            If Not TransStatus_Aktiv Is Nothing Then
                If Not TransStatus_Aktiv.MoveCurrentToNext Then TransStatus_Aktiv.MoveCurrentToPrevious()
                If Not TransStatus_Aktiv.IsAddingNew Or TransStatus_Aktiv.IsEditingItem Then TransStatus_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.ObjAktiv)
            End If
            'Update all Account Status Amounts:
            Call Konto_set_stati_all()
        End Sub

#Region "Commands"
        Public Property cmdTransStatusImage As New RelayCommand(Of trans_status_v01)(Sub(p) TransStatusImage(p), Function(p) p IsNot Nothing)

        Private Sub TransStatusImage(v_tt As trans_status_v01)
            If v_tt Is Nothing Then Exit Sub
            Dim v_image As Byte() = get_symbol_from_dialog()
            If v_image IsNot Nothing Then
                v_tt.symbol = v_image
            End If
        End Sub

#End Region

#Region "ShortcutKeys"
        Public Property shortcut_keys As New List(Of String) From {
        "",
        "b",
        "d",
        "e",
        "f",
        "g",
        "h",
        "i",
        "j",
        "k",
        "l",
        "m",
        "n",
        "o",
        "p",
        "q",
        "r",
        "s",
        "t",
        "u",
        "w",
        "y",
        "z"}
#End Region

    End Class
End Namespace

