﻿Imports System.Collections.ObjectModel
Imports System.Data.Entity

Namespace HHHB3.ViewModel
    Partial Public Class MainViewModel
        'Partial Entität Tags:

        Private WithEvents __tags As New ObservableCollection(Of tags_v01)
        ''' <summary>
        ''' Alle Transaktionstypen
        ''' </summary>
        ''' <returns></returns>
        Public Property Tags As ListCollectionView
        Public Property Tags_Aktiv As ListCollectionView

        Private Sub TagsLoad()
            __tags.Clear()
            dbo.m_tags_v01.Load
            __tags = dbo.m_tags_v01.Local
            Tags = New ListCollectionView(__tags)
            Tags_Aktiv = New ListCollectionView(__tags)
            Tags_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.ObjAktiv)
        End Sub

        Private Sub __tags_CollectionChanged(sender As Object, e As Specialized.NotifyCollectionChangedEventArgs) Handles __tags.CollectionChanged
            'If e.Action <> Specialized.NotifyCollectionChangedAction.Remove Then Return
            If Not Tags Is Nothing Then
                If Not Tags.MoveCurrentToNext Then Tags.MoveCurrentToPrevious()
            End If
            If Not Tags_Aktiv Is Nothing Then
                If Not Tags_Aktiv.MoveCurrentToNext Then Tags_Aktiv.MoveCurrentToPrevious()
                If Not Tags_Aktiv.IsAddingNew Or Tags_Aktiv.IsEditingItem Then Tags_Aktiv.Filter = New Predicate(Of Object)(AddressOf Filters.ObjAktiv)
            End If
        End Sub

#Region "Commands"
        Public Property cmdTagImage As New RelayCommand(Of tags_v01)(Sub(p) TagImage(p), Function(p) p IsNot Nothing)
        Private Sub TagImage(v_tag As tags_v01)
            If v_tag Is Nothing Then Exit Sub
            Dim v_image As Byte() = get_symbol_from_dialog()
            If v_image IsNot Nothing Then
                v_tag.symbol = v_image
            End If
        End Sub
#End Region

    End Class
End Namespace

