﻿Namespace HHHB3.Selectors
    ''' <summary>
    ''' Header Template Selector fürs AVALON Dock
    ''' </summary>
    Public Class avalon_templateselector
        Inherits DataTemplateSelector
        Public Property StandardTemplate() As DataTemplate
            Get
                Return m_standardtemplate
            End Get
            Set
                m_standardtemplate = Value
            End Set
        End Property
        Private m_standardtemplate As DataTemplate

        Public Property SettingsTemplate() As DataTemplate
            Get
                Return m_settingstemplate
            End Get
            Set
                m_settingstemplate = Value
            End Set
        End Property
        Private m_settingstemplate As DataTemplate

        Private m_VerwaltungTemplate As DataTemplate
        Public Property VerwaltungTemplate As DataTemplate
            Get
                Return m_VerwaltungTemplate
            End Get
            Set(value As DataTemplate)
                m_VerwaltungTemplate = value
            End Set
        End Property

        Private m_HomeTemplate As DataTemplate
        Public Property HomeTemplate As DataTemplate
            Get
                Return m_HomeTemplate
            End Get
            Set(value As DataTemplate)
                m_HomeTemplate = value
            End Set
        End Property

        Private m_kontotemplate As DataTemplate
        Public Property KontoTemplate As DataTemplate
            Get
                Return m_kontotemplate
            End Get
            Set(value As DataTemplate)
                m_kontotemplate = value
            End Set
        End Property

        Private m_kontojournaltemplate As DataTemplate
        Public Property KontoJournalTemplate As DataTemplate
            Get
                Return m_kontojournaltemplate
            End Get
            Set(value As DataTemplate)
                m_kontojournaltemplate = value
            End Set
        End Property

        Private m_kontoreporttemplate As DataTemplate
        Public Property KontoReportTemplate As DataTemplate
            Get
                Return m_kontoreporttemplate
            End Get
            Set(value As DataTemplate)
                m_kontoreporttemplate = value
            End Set
        End Property

        Private m_searchtemplate As DataTemplate
        Public Property SearchTemplate As DataTemplate
            Get
                Return m_searchtemplate
            End Get
            Set(value As DataTemplate)
                m_searchtemplate = value
            End Set
        End Property

        Private m_budgettemplate As DataTemplate
        Public Property BudgetTemplate As DataTemplate
            Get
                Return m_budgettemplate
            End Get
            Set(value As DataTemplate)
                m_budgettemplate = value
            End Set
        End Property

        Private m_transreptemplate As DataTemplate
        Public Property TransRepTemplate As DataTemplate
            Get
                Return m_transreptemplate
            End Get
            Set(value As DataTemplate)
                m_transreptemplate = value
            End Set
        End Property

        Private m_transtemptemplate As DataTemplate
        Public Property TransTempTemplate As DataTemplate
            Get
                Return m_transtemptemplate
            End Get
            Set(value As DataTemplate)
                m_transtemptemplate = value
            End Set
        End Property

        Private m_transstacktemplate As DataTemplate
        Public Property TransStackTemplate As DataTemplate
            Get
                Return m_transstacktemplate
            End Get
            Set(value As DataTemplate)
                m_transstacktemplate = value
            End Set
        End Property

        Private m_documentstemplate As DataTemplate
        Public Property DocumentsTemplate As DataTemplate
            Get
                Return m_documentstemplate
            End Get
            Set(value As DataTemplate)
                m_documentstemplate = value
            End Set
        End Property

        Private m_archivtemplate As DataTemplate
        Public Property ArchivTemplate As DataTemplate
            Get
                Return m_archivtemplate
            End Get
            Set(value As DataTemplate)
                m_archivtemplate = value
            End Set
        End Property

        Private m_balancertemplate As DataTemplate
        Public Property BalancerTemplate As DataTemplate
            Get
                Return m_balancertemplate
            End Get
            Set(value As DataTemplate)
                m_balancertemplate = value
            End Set
        End Property

        Private m_savingtargettemplate As DataTemplate
        Public Property SavingTargetTemplate As DataTemplate
            Get
                Return m_savingtargettemplate
            End Get
            Set(value As DataTemplate)
                m_savingtargettemplate = value
            End Set
        End Property



        'Templates for the different reports:
        Public Property RepCapitalTemplate As DataTemplate
            Get
                Return m_rep_capital
            End Get
            Set(value As DataTemplate)
                m_rep_capital = value
            End Set
        End Property
        Private m_rep_capital As DataTemplate


        Public Property RepFoldertransTemplate As DataTemplate
            Get
                Return m_rep_foldertrans
            End Get
            Set(value As DataTemplate)
                m_rep_foldertrans = value
            End Set
        End Property
        Private m_rep_foldertrans As DataTemplate

        Public Property RepEinausTemplate As DataTemplate
            Get
                Return m_rep_einaus
            End Get
            Set(value As DataTemplate)
                m_rep_einaus = value
            End Set
        End Property
        Private m_rep_einaus As DataTemplate

        Public Property RepEinTemplate As DataTemplate
            Get
                Return m_rep_ein
            End Get
            Set(value As DataTemplate)
                m_rep_ein = value
            End Set
        End Property
        Private m_rep_ein As DataTemplate

        Public Property RepAusTemplate As DataTemplate
            Get
                Return m_rep_aus
            End Get
            Set(value As DataTemplate)
                m_rep_aus = value
            End Set
        End Property
        Private m_rep_aus As DataTemplate

        Public Property RepCatsTemplate As DataTemplate
            Get
                Return m_rep_cats
            End Get
            Set(value As DataTemplate)
                m_rep_cats = value
            End Set
        End Property
        Private m_rep_cats As DataTemplate

        Public Property RepTopCatsTemplate As DataTemplate
            Get
                Return m_rep_topcats
            End Get
            Set(value As DataTemplate)
                m_rep_topcats = value
            End Set
        End Property
        Private m_rep_topcats As DataTemplate

        Public Property RepReceiverTemplate As DataTemplate
            Get
                Return m_rep_receiver
            End Get
            Set(value As DataTemplate)
                m_rep_receiver = value
            End Set
        End Property
        Private m_rep_receiver As DataTemplate

        Public Property RepTopReceiverTemplate As DataTemplate
            Get
                Return m_rep_topreceiver
            End Get
            Set(value As DataTemplate)
                m_rep_topreceiver = value
            End Set
        End Property
        Private m_rep_topreceiver As DataTemplate

        Public Property RepPersonTemplate As DataTemplate
            Get
                Return m_rep_person
            End Get
            Set(value As DataTemplate)
                m_rep_person = value
            End Set
        End Property
        Private m_rep_person As DataTemplate

        Public Property RepTopPersonTemplate As DataTemplate
            Get
                Return m_rep_topperson
            End Get
            Set(value As DataTemplate)
                m_rep_topperson = value
            End Set
        End Property
        Private m_rep_topperson As DataTemplate

        Public Property RepPeriodsTemplate As DataTemplate
            Get
                Return m_rep_periods
            End Get
            Set(value As DataTemplate)
                m_rep_periods = value
            End Set
        End Property
        Private m_rep_periods As DataTemplate



        Public Overrides Function SelectTemplate(item As Object, container As DependencyObject) As DataTemplate
            Dim v_realcontent As New Object

            Select Case True
                Case TypeOf (item) Is Xceed.Wpf.AvalonDock.Layout.LayoutDocument
                    Dim v_realitem As Xceed.Wpf.AvalonDock.Layout.LayoutDocument = DirectCast(item, Xceed.Wpf.AvalonDock.Layout.LayoutDocument)
                    v_realcontent = v_realitem.Content
                Case TypeOf (item) Is System.Windows.Controls.ContentPresenter
                    Dim v_realitem As System.Windows.Controls.ContentPresenter = DirectCast(item, ContentPresenter)
                    v_realcontent = v_realitem.Content
                Case Else
                    Return StandardTemplate
            End Select

            Select Case True
                Case TypeOf (v_realcontent) Is settings
                    Return SettingsTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_verwaltung
                    Return VerwaltungTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_home
                    Return HomeTemplate
                Case TypeOf (v_realcontent) Is konto_v01
                    Return KontoTemplate
                Case TypeOf (v_realcontent) Is bookjournal_v01
                    Return KontoJournalTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_kontoreport
                    Return KontoReportTemplate
                Case TypeOf (v_realcontent) Is searchdefinition_v01
                    Return SearchTemplate
                Case TypeOf (v_realcontent) Is budget_v01
                    Return BudgetTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_transrep_overview
                    Return TransRepTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_transtemp_overview
                    Return TransTempTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_transstack
                    Return TransStackTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_documents
                    Return DocumentsTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_archiv
                    Return ArchivTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_balancer
                    Return BalancerTemplate
                Case TypeOf (v_realcontent) Is cls_menuitem_savingtargets
                    Return SavingTargetTemplate
                Case TypeOf (v_realcontent) Is report_base_v01
                    Dim v_repbase As report_base_v01 = DirectCast(v_realcontent, report_base_v01)
                    Select Case v_repbase.type
                        Case "rep_capital"
                            Return RepCapitalTemplate
                        Case "rep_foldertrans"
                            Return RepFoldertransTemplate
                        Case "rep_einaus"
                            Return RepEinausTemplate
                        Case "rep_ein"
                            Return RepEinTemplate
                        Case "rep_aus"
                            Return RepAusTemplate
                        Case "rep_cats"
                            Return RepCatsTemplate
                        Case "rep_topcats"
                            Return RepTopCatsTemplate
                        Case "rep_receiver"
                            Return RepReceiverTemplate
                        Case "rep_topreceiver"
                            Return RepTopReceiverTemplate
                        Case "rep_person"
                            Return RepPersonTemplate
                        Case "rep_topperson"
                            Return RepTopPersonTemplate
                        Case "rep_periods"
                            Return RepPeriodsTemplate
                        Case Else
                            Return StandardTemplate
                    End Select
                Case Else
                    Return StandardTemplate
            End Select
            Return MyBase.SelectTemplate(item, container)
        End Function

    End Class
End Namespace
