﻿Namespace HHHB3.Selectors
    Public Class dashboard_templateselector
        Inherits DataTemplateSelector

        Public Property StandardTemplate() As DataTemplate
            Get
                Return m_standardtemplate
            End Get
            Set
                m_standardtemplate = Value
            End Set
        End Property
        Private m_standardtemplate As DataTemplate

        Dim v_einaus As DataTemplate
        Public Property EinausTemplate As DataTemplate
            Get
                Return v_einaus
            End Get
            Set(value As DataTemplate)
                v_einaus = value
            End Set
        End Property

        Dim v_grafic As DataTemplate
        Public Property GraficTemplate As DataTemplate
            Get
                Return v_grafic
            End Get
            Set(value As DataTemplate)
                v_grafic = value
            End Set
        End Property

        Dim v_messages As DataTemplate
        Public Property MessagesTemplate As DataTemplate
            Get
                Return v_messages
            End Get
            Set(value As DataTemplate)
                v_messages = value
            End Set
        End Property

        Dim v_overview As DataTemplate
        Public Property OverviewTemplate As DataTemplate
            Get
                Return v_overview
            End Get
            Set(value As DataTemplate)
                v_overview = value
            End Set
        End Property

        Dim v_topcats As DataTemplate
        Public Property TopcatsTemplate As DataTemplate
            Get
                Return v_topcats
            End Get
            Set(value As DataTemplate)
                v_topcats = value
            End Set
        End Property

        Dim v_cats As DataTemplate
        Public Property CatsTemplate As DataTemplate
            Get
                Return v_cats
            End Get
            Set(value As DataTemplate)
                v_cats = value
            End Set
        End Property

        Dim v_upcoming As DataTemplate
        Public Property UpcomingTemplate As DataTemplate
            Get
                Return v_upcoming
            End Get
            Set(value As DataTemplate)
                v_upcoming = value
            End Set
        End Property

        Dim v_targetgauge As DataTemplate
        Public Property TargetGaugeTemplate As DataTemplate
            Get
                Return v_targetgauge
            End Get
            Set(value As DataTemplate)
                v_targetgauge = value
            End Set
        End Property

        'Receiver:
        Dim v_topreceivers As DataTemplate
        Public Property TopReceiversTemplate As DataTemplate
            Get
                Return v_topreceivers
            End Get
            Set(value As DataTemplate)
                v_topreceivers = value
            End Set
        End Property

        Dim v_receivers As DataTemplate
        Public Property ReceiversTemplate As DataTemplate
            Get
                Return v_receivers
            End Get
            Set(value As DataTemplate)
                v_receivers = value
            End Set
        End Property

        'Persons:
        Dim v_toppersons As DataTemplate
        Public Property TopPersonsTemplate As DataTemplate
            Get
                Return v_toppersons
            End Get
            Set(value As DataTemplate)
                v_toppersons = value
            End Set
        End Property

        Dim v_persons As DataTemplate
        Public Property PersonsTemplate As DataTemplate
            Get
                Return v_persons
            End Get
            Set(value As DataTemplate)
                v_persons = value
            End Set
        End Property


        Public Overrides Function SelectTemplate(item As Object, container As DependencyObject) As DataTemplate
            If item Is Nothing Then Return StandardTemplate

            Select Case True
                Case TypeOf (item) Is cls_home_einaus
                    Return EinausTemplate
                Case TypeOf (item) Is cls_home_grafic
                    Return GraficTemplate
                Case TypeOf (item) Is cls_home_messages
                    Return MessagesTemplate
                Case TypeOf (item) Is cls_home_overview
                    Return OverviewTemplate
                Case TypeOf (item) Is cls_home_topcats
                    Return TopcatsTemplate
                Case TypeOf (item) Is cls_home_cats
                    Return CatsTemplate
                Case TypeOf (item) Is cls_home_upcoming
                    Return UpcomingTemplate
                Case TypeOf (item) Is cls_home_targetgauge
                    Return TargetGaugeTemplate
                Case TypeOf (item) Is cls_home_toppersons
                    Return TopPersonsTemplate
                Case TypeOf (item) Is cls_home_persons
                    Return PersonsTemplate
                Case TypeOf (item) Is cls_home_topreceivers
                    Return TopReceiversTemplate
                Case TypeOf (item) Is cls_home_receivers
                    Return ReceiversTemplate
                Case Else
                    Return StandardTemplate
            End Select


        End Function


    End Class
End Namespace

