﻿Imports System.ComponentModel.DataAnnotations
Imports System.Collections.ObjectModel
Imports System.ComponentModel.DataAnnotations.Schema
Imports System.Collections.Specialized
Imports System.ComponentModel

Public Class import_definition_row
    Inherits model_base

    Dim v_id As Integer
    Dim v_parent_id As Integer
    Dim v_sorter As Integer = 1
    Dim v_columnname As String

#Region "Mapped"
    <Key>
    Public Property Id As Integer
        Get
            Return v_id
        End Get
        Set(value As Integer)
            If v_id <> value Then
                v_id = value
                NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    Public Property parent_id As Integer
        Get
            Return v_parent_id
        End Get
        Set(value As Integer)
            If v_parent_id <> value Then
                v_parent_id = value
                NotifyPropertyChanged("parent_id")
            End If
        End Set
    End Property

    Public Property sorter As Integer
        Get
            Return v_sorter
        End Get
        Set(value As Integer)
            If v_sorter <> value Then
                v_sorter = value
                NotifyPropertyChanged("sorter")
            End If
        End Set
    End Property

    Public Property columnname As String
        Get
            Return v_columnname
        End Get
        Set(value As String)
            If v_columnname <> value Then
                v_columnname = value
                NotifyPropertyChanged("columnname")
            End If
        End Set
    End Property
#End Region

#Region "Navigation Properties"
    <ForeignKey("parent_id")>
    Public Property nv_import_definition_head As import_definition_head
        Get
            Return v_nv_import_definition_head
        End Get
        Set(value As import_definition_head)
            If v_nv_import_definition_head IsNot value Then
                v_nv_import_definition_head = value
                NotifyPropertyChanged("nv_import_definition_head")
            End If
        End Set
    End Property

    Dim v_nv_import_definition_head As import_definition_head
#End Region

#Region "ErrorInterface"
    ''' <summary>
    ''' Routine für die Fehlervalidierung
    ''' </summary>
    ''' <param name="columnName"></param>
    ''' <returns></returns>
    Public Overrides ReadOnly Property ErrorItem(columnName As String) As String
        Get
            Return String.Empty
        End Get
    End Property
#End Region

End Class
