﻿Imports LiveCharts

Public Class cls_home_einaus
    Inherits cls_dashboard_base

    Public Overrides ReadOnly Property widget_bezeichnung As String
        Get
            Return "Einnahmen zu Ausgaben"
        End Get
    End Property

    'Properties of the Widget himself:
    Public Property Chart_InOut_Series As SeriesCollection = New SeriesCollection
    Public Property Chart_InOut_Labels As New List(Of String) From {"Einnahmen", "Ausgaben"}
    Public Property Chart_InOut_Formatter As Func(Of Double, String) = Function(value) value.ToString("N")

    'Start and End Date for Chart:
    'Dim v_chart_inout_startdate As Date = New Date(Date.Now.Year, Date.Now.Month, 1)
    'Dim v_chart_inout_enddate As Date = New Date(Date.Now.Year, Date.Now.Month + 1, 1).AddDays(-1)

    Public Property Chart_InOut_StartDate As Date
        Get
            Return CDate(DBWidget.para_date1)
        End Get
        Set(value As Date)
            If DBWidget.para_date1 <> value Then
                'Also update the Parameterdate in database:
                DBWidget.para_date1 = value
                NotifyPropertyChanged("Chart_InOut_StartDate")
                NotifyPropertyChanged("DBWidget")
            End If
        End Set
    End Property

    Public Property Chart_InOut_EndDate As Date
        Get
            Return CDate(DBWidget.para_date2)
        End Get
        Set(value As Date)
            If DBWidget.para_date2 <> value Then
                DBWidget.para_date2 = value
                NotifyPropertyChanged("Chart_InOut_EndDate")
                NotifyPropertyChanged("DBWidget")
            End If
        End Set
    End Property

End Class
