﻿''' <summary>
''' Defines a Item for a periodical Report
''' Contains a name, a start and enddate and finally a value
''' </summary>
Public Class cls_repperiod_perioditem
    Inherits GalaSoft.MvvmLight.ObservableObject


    Dim v_bezeichnung As String
    Dim v_start As Date
    Dim v_end As Date
    Dim v_amount As Decimal = 0D

    Sub New()

    End Sub

    Sub New(v_bez As String, v_start As Date, v_end As Date, v_value As Decimal)
        Bezeichnung = v_bez
        StartDate = v_start
        EndDate = v_end
        Amount = v_value
    End Sub

    Public Property Bezeichnung As String
        Get
            Return v_bezeichnung
        End Get
        Set(value As String)
            If v_bezeichnung <> value Then
                v_bezeichnung = value
                RaisePropertyChanged("Bezeichnung")
            End If
        End Set
    End Property

    Public Property StartDate As Date
        Get
            Return v_start
        End Get
        Set(value As Date)
            If v_start <> value Then
                v_start = value
                RaisePropertyChanged("StartDate")
            End If
        End Set
    End Property

    Public Property EndDate As Date
        Get
            Return v_end
        End Get
        Set(value As Date)
            If v_end <> value Then
                v_end = value
                RaisePropertyChanged("EndDate")
            End If
        End Set
    End Property

    Public Property Amount As Decimal
        Get
            Return v_amount
        End Get
        Set(value As Decimal)
            If v_amount <> value Then
                v_amount = value
                RaisePropertyChanged("Amount")
            End If
        End Set
    End Property


End Class
